/*
 * Various dummy and debug routines.
 *
 * Copyright (C) 1994, 1995 by Waldorf Electronics,
 * written by Ralf Baechle.
 */

#include <linux/string.h>

#include <asm/mipsregs.h>
#include <asm/mipsconfig.h>
#include <asm/cachectl.h>

void dump_tlb(void)
{
	int	i;
	int	wired;
	unsigned long long bigreg;

	wired = read_32bit_cp0_register(CP0_WIRED);
	printk("Wired: %d", wired);
	
	for(i=0;i<=47;i++) {
		write_32bit_cp0_register(CP0_INDEX, i);
		__asm__ __volatile__("nop;tlbr");

		printk("\nIndex: %2d  %08x", i,
			 read_32bit_cp0_register(CP0_PAGEMASK));

		bigreg = read_64bit_cp0_register(CP0_ENTRYHI);
		printk("  %08x %08x", (unsigned long)(bigreg >> 32), (unsigned long) bigreg);

		bigreg = read_64bit_cp0_register(CP0_ENTRYLO0);
		printk("  %08x %08x", (unsigned long)(bigreg >> 32), (unsigned long) bigreg);

		bigreg = read_64bit_cp0_register(CP0_ENTRYLO1);
		printk("  %08x %08x", (unsigned long)(bigreg >> 32), (unsigned long) bigreg);
		}
}

void dump_tables(void)
{
	extern unsigned long swapper_pg_dir[1024];
	unsigned long	*pg, *pt;
	int		i, j;

	sys_cacheflush(0, ~0, BCACHE);
	/*
	 * Clear ERL/EXL flags
	 */
	__asm__ __volatile__(
		".set noat\n\t"
		"mfc0 $1,$12\n\t"
		"ori $1,$1,6\n\t"
		"xori $1,$1,6\n\t"
		"mtc0 $1,$12\n\t"
		".set at");
	pg = (unsigned long *) ((unsigned long)swapper_pg_dir - KERNELBASE);
	printk("PageDir: %x\n", pg);
	for(i=0;i<4;i++,pg++) {
		printk("\npg_dir[%d] = %08x", i, *pg);
		pt = *pg & 0xfffff000;
		for(j=0;j<16;j++,pt++) {
			if(!(j & 7))
				printk("\n");
			printk("%08x ", *pt);
			}
		}
}
